<?php

/**
 * Envio de Newsletter pelo Admin Prestashop 1.1
 * @category admin
 *
 * @author Odlanier de Souza <master_odlanier@hotmail.com>
 * @contributor Leighton Whiting http://blog.leightonwhiting.com 
 * @copyright prestashopbr.com
 * @license http://www.opensource.org/licenses/osl-3.0.php Open-source licence 3.0
 * @version 0.4
 *
 */

// Function to check for emails in the array : Added by Leighton Whiting 2-20-2009
function recursive_in_array($needle, $haystack) {
    foreach ($haystack as $stalk) {
        if ($needle === $stalk || (is_array($stalk) && recursive_in_array($needle, $stalk))) {
            return true;
        }
    }
    return false;
}

include_once (PS_ADMIN_DIR . '/../classes/AdminTab.php');

class AdminNewsletter extends AdminTab
{


    public function display()
    {
        global $currentIndex, $cookie;
        if (Tools::getValue('send') != 1)
        {

            $iso = Language::getIsoById(intval($cookie->id_lang));

            echo $this->html = '
		<h2>' . $this->l('Newsletter') 	. '</h2><p>'  . 
				$this->l('Variables:') 	. '   '	.
				$this->l('%FIRSTNAME%') . ' - ' . 
				$this->l('%LASTNAME%') 	. ' - ' . 
				$this->l('%MAIL%') 		. '</p>
		
		<form action="' . $currentIndex . '&token=' . $this->token .
                '&send=1" method="post" >
		
		<fieldset>
		<legend>'.$this->l('Filters').':</legend><br/>
		<input type="checkbox" name="sNewsletter" 	value="1" /> '.
		$this->l('Newsletter Block Subscribers').'
		<br />
		<input type="checkbox" name="sSubscribers" 	value="1" /> '.
		$this->l('Customers who signed up for Newsletter').'
		<br />
		<input type="checkbox" name="sCustomers" 	value="1" /> '.
		$this->l('All Customers').'
		<br />
		</fieldset>
		
		<br />
		
		<fieldset>
		<legend>'.$this->l('Subject').':</legend><br/>
		<input type="text" name="subject_email" style="width: 100%" />
		</fieldset>
		
		<br/>
		
		<fieldset>
		<legend>'.$this->l('Message').':</legend>
		
		<br/>
						
		<script type="text/javascript" src="../js/tinymce/jscripts/tiny_mce/tiny_mce_gzip.js"></script>
			<script type="text/javascript">
				tinyMCE_GZ.init({
					plugins : "contextmenu, directionality, media, paste, preview, safari, template",
					themes : "advanced",
					languages : "en",
					disk_cache : false,
					debug : false
				});
			</script>
			<script type="text/javascript">
				tinyMCE.init({
					mode : "textareas",
					plugins : "contextmenu, directionality, media, paste, preview, safari, template",
					theme : "advanced",
					language : "en",
					elements : "nourlconvert",
					convert_urls : false,
					theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect", 
					theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,forecolor,backcolor,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,template,|,ltr,rtl,|,fullscreen", 
					theme_advanced_buttons3 : "", 					 

					theme_advanced_toolbar_location : "top",
					theme_advanced_toolbar_align : "left",
					theme_advanced_buttons3_add : "ltr,rtl,pastetext,pasteword,selectall",
					theme_advanced_buttons1_add : "media,preview",
					paste_create_paragraphs : false,
					paste_create_linebreaks : false,
					paste_use_dialog : true,
					paste_auto_cleanup_on_paste : true,
					paste_convert_middot_lists : false,
					paste_unindented_list_class : "unindentedList",
					paste_convert_headers_to_strong : true,
					plugin_preview_width : "500",
					plugin_preview_height : "900",
					extended_valid_elements : "a[name|href|target|title|onclick],img[class|src|border=0|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name],hr[class|width|size|noshade],font[face|size|color|style],span[class|align|style]",
					
					template_external_list_url : "../js/tinymce/jscripts/tiny_mce/lists/template_list.php"
					
				});	
						//getE(\'cdesc_2\').style.display = \'none\';
						//getE(\'cdesc_short_2\').style.display = \'none\';
						//getE(\'cdesc_2\').rows = 54;
						//getE(\'cdesc_short_2\').rows = 54;
						//getE(\'cdesc_2\').cols = 10;
						//getE(\'cdesc_short_2\').cols = 8;</script>
		
		<textarea name="body_email" style="width:100%; height: 300px;">
		</textarea>
		
		<br />
		
		<div align="right">
		<input type="submit" name="send_newsletter" value="'.
		$this->l('Send Mail').'" class="button" />
		</div>
		</fieldset>
		</form>
		';


            //var_dump($newsletter);

        }
    }

    public function postProcess()
    {
        global $currentIndex, $cookie;
        
        if (Tools::getValue('send') == 1)
        {
            //Get the Checkbox Values : Added by Leighton Whiting 2-20-2009
            $sCustomers 		= Tools::getValue('sCustomers');
            $sSubscribers 		= Tools::getValue('sNewsletter');
            $sNewsletter 		= Tools::getValue('sSubscribers');
            
            $customers 			= Customer::getCustomers();
            $newsletter 		= Customer::getNewsletteremails();
            
            //Get the Newsletter Block Subscribers : Added by Leighton Whiting 2-20-2009
            $rq = Db::getInstance()->ExecuteS('
        		SELECT *
        		FROM `'._DB_PREFIX_.'newsletter`');
        		$bNewsletters = (is_array($rq) ? $rq : 0);
        		
            $email_from 		= Configuration::get('PS_SHOP_EMAIL');
            $name 				= Configuration::get('PS_SHOP_NAME');
            
            //Build the Array to send : Added by Leighton Whiting 2-20-2009
            $sendList = Array();
            if ($sCustomers AND is_array($customers)){$sendList = $customers;}
            if ($sNewsletter AND is_array($bNewsletters)){$sendList = array_merge($sendList,$bNewsletters);}
            if ($sSubscribers AND is_array($newsletter)){$sendList = array_merge($sendList,$newsletter);}
            
            //Clean Duplicates from the Array : Added by Leighton Whiting 2-20-2009
            $finalList = Array();
            foreach ($sendList as $item){
            if (!recursive_in_array($item['email'],$finalList)){$finalList[] = $item;}
            }

            echo '<fieldset>
			<legend>'.$this->l('Report').'</legend><br>
			<table border="1" width="100%" style="border-collapse: collapse;" 
			cellpadding="2" bordercolor="#e0d0b1" >
			<tr>
				<td align="center"><b>'.$this->l('FIRSTNAME').'</b></td>
				<td align="center"><b>'.$this->l('LASTNAME').'</b></td>
				<td align="center"><b>'.$this->l('E-MAIL').'</b></td>
				<td align="center"><b>'.$this->l('STATUS').'</b></td>
			</tr>
			';

            foreach ($finalList as $id => $value)
            {

                //%EMAIL% - %NOME% - %SOBRENOME%

                $html 			= Tools::getValue('body_email');
                $assunto 		= Tools::getValue('subject_email');

                //Put 'Subscriber' if firstname is not set : Added by Leighton Whiting 2-20-2009
                $firstname 		= ($value['firstname']) ? $value['firstname'] : $this->l('Subscriber');
                $lastname 		= $value['lastname'];
                $email 			= $value['email'];

                $html 			= str_replace($this->l('%FIRSTNAME%'), $firstname, $html);
                $html 			= str_replace($this->l('%LASTNAME%'), $lastname, $html);
                $html 			= str_replace($this->l('%MAIL%'), $email, $html);

                $assunto 		= str_replace($this->l('%FIRSTNAME%'), $firstname, $assunto);
                $assunto 		= str_replace($this->l('%LASTNAME%'), $lastname, $assunto);
                $assunto 		= str_replace($this->l('%MAIL%'), $email, $assunto);

                unset($headers);
                $headers 		= "MIME-Version: 1.0\r\n";
                $headers 	   .= "Content-type: text/html; charset=iso-8859-1\r\n";
                $headers 	   .= "X-Priority: 1\r\n";
                $headers 	   .= "X-MSMail-Priority: High\r\n";
                $headers 	   .= "Disposition-Notification-To: $email_from\r\n" . $headers .=
                    "Reply-To: $email_from\r\n";
                $headers 	   .= "From: $name <$email_from>\r\n";
                $headers 	   .= "Organization: $name\r\n";

                $mensagem 		= nl2br($html);

				$Mail_Send 		= new Mail();
				
				$send 			= Mail::Send(intval($cookie->id_lang), 'newsletter', $assunto, array('{email}' => $email_from, '{message}' => stripslashes($mensagem)), $email);
				
                //$send = mail("$email", "$assunto", "$mensagem", "$headers", "-f $email_from");

                echo '
					<tr>
					 	<td>&nbsp;' . $firstname . '</td>
						<td>&nbsp;' . $lastname . '</td>
						<td>&nbsp;' . $email . '</td>
						<td align="center">';
                if ($send)
                {
                    echo ("<font color=\"GREEN\"> ".$this->l('SUCESS!')." </font> <br>");
                } else
                {
                    echo ("<font color=\"RED\"> ".$this->l('FAILED')." </font> <br>");
                }

                echo ' </td>
				</tr>
				';


            }

            /** BOTO VOLTAR **/
            echo '
			</table>
			</fieldset>
			
			<form action="' . $currentIndex . '&token=' . $this->token .
                '&send=0" method="post" >
            <div align="right"><br />
			<input type="submit" name="voltar" value="'.
			$this->l('Back').'" class="button" />
			</div>
			</form>
			';

        }

    }


}

?>